/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef COORDINATE_H
#define COORDINATE_H

#include"radian.h"
#include<qstring.h>

/*
 #define _DEBUG_PRINT
 */

class Coordinate {
public:
	Coordinate(long radEW = 0, long radNS = 0, int intHight = 0);
	Coordinate(Radian radEW, Radian radNS, int intHight = 0);
	void setRadEW(Radian radEW);
	void setRadNS(Radian radNS);
	void setIntHight(int intHight);
	Radian getRadEW();
	Radian getRadNS();
	int getIntHight();
	QString toString();
	bool parse(const QString &str);
	void convTokyoToWGS84();
	void convWGS84ToTokyo();
	Coordinate& operator=(Coordinate value);

private:
	Radian _radEW;
	Radian _radNS;
	int _intHight;
};

#endif //COORDINATE_H
