/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef CUSTOMMAPLIST_H
#define CUSTOMMAPLIST_H

#include<qdir.h>
#include<qstringlist.h>
#include<qtextstream.h>
#include<qfile.h>
#include<map>
#include"maplist.h"

#include<stdio.h>

class CustomMapList : public MapList {
public:
	CustomMapList();
	~CustomMapList();
	QString searchMapFileName(long ns, long ew, Radian *radMapEW,
			Radian *radMapNS, Radian *radMapWidth, Radian *radMapHeight);
	QString pointMapFileName(int diffLat, int diffLong, Radian *radMapEW,
			Radian *radMapNS, Radian *radMapWidth, Radian *radMapHeight);
	void createMapList();
	void changeMap(const QString &path);
	QString getClassName() {
		return "CustomMapList";
	}

private:
	void updateItudeList(const QString &path, map<long, int> *longitude,
			map<long, int> *latitude, unsigned int * maxFileLen);
	void updateMapList(const QString &path, QFile *mapListFile);
	bool getMapInfo(QString mapFileName, Radian *radMapEW, Radian *radMapNS,
			Radian *radMapWidth, Radian *radMapHeight);

	QString _basePath;
	QFile _mapListFile;
	map<long, int> _latitude;
	map<long, int> _longitude;
	int _latid, _longid;
	unsigned int _maxFileLen;
	unsigned long _baseLength;

	//const long _index_size = sizeof(Q_UINT32) + sizeof(long) * 2;
	//Q_UINT32 _magicNumber = 0x15614878;
};

#endif //CUSTOMMAPLIST_H
