/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef DRAWINFO_H
#define DRAWINFO_H
#include<qpainter.h>
#include<map.h>
#include<vector.h>
#include"coordinate.h"
#include"route.h"
#include"gpsloghandler.h"

// Х᥽åɤؤΥݥ󥿤
typedef class DrawInfo cDrawInfo;
typedef void (cDrawInfo::*DrawInfoFunc)(const QStringList *);

// ɽ(vector) ᥽åɥݥ󥿤ȥѥ᡼(ʸ)
class FormInfo {
public:
	FormInfo();
	FormInfo(DrawInfoFunc apfunc, QStringList adata);
	DrawInfoFunc pfunc;
	QStringList data;
};

class DrawInfo {
public:
	DrawInfo(QPaintDevice *paintDevice, int pd_width, int pd_height,
			Route *route, GpsLogHandler *gpsLogHandler, Coordinate *centerCoordinate);
	~DrawInfo();
	void repaint();
	void setFormat(QString format);
	void dummy(const QStringList *pstrlist);
	void setLineHight(const QStringList *pstrlist);
	void setFont(const QStringList *pstrlist);
	void setColor(const QStringList *pstrlist);
	void setText(const QStringList *pstrlist);
	void newLine(const QStringList *pstrlist);
	void setLat(const QStringList *pstrlist);
	void setLon(const QStringList *pstrlist);
	void setDate(const QStringList *pstrlist);
	void setTime(const QStringList *pstrlist);
	void setSpeed(const QStringList *pstrlist);
	void setHeight(const QStringList *pstrlist);
	void setDirection(const QStringList *pstrlist);
	void setSatelliteNum(const QStringList *pstrlist);
	void setRouteTotal(const QStringList *pstrlist);
	void setRouteRemain(const QStringList *pstrlist);
	void setRouteNext(const QStringList *pstrlist);
	void setRouteBegin(const QStringList *pstrlist);
	void setRouteEnd(const QStringList *pstrlist);
	void drawText();
	void setGeometry(int x, int y, int width);
	void resize(int width, int height);

	double _routeLength;
	double _remainRouteLength;
	double _currentNearLength;

private:
	vector<FormInfo> _forms;
	QPaintDevice *_paintDevice;
	int _pd_width, _pd_height;
	QPainter *_painter;
	QPixmap *_drawBuffer;
	int _base_x, _base_y, _x, _y;
	int _width, _height;
	int _line_height, _padding;
	map<QString, DrawInfoFunc> _funcmap;
	QString _strData;
	Coordinate _coordinate;
	Route *_route;
	GpsLogHandler *_gpsLogHandler;
	Coordinate *_centerCoordinate;
};

#endif //DRAWINFO_H
