/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include"gm_litemaps.h"
#include"coordinate.h"
#include<math.h>
#include<iostream.h>

GM_LiteMaps::GM_LiteMaps(const QString &path = "/mnt/card/gm_lite/imgs") {
	_basePath = path;
	// 
    _scale = 13;
	// 祹
	_maxScale = 20;
	// ɸ
	_imageSize = 256;
	// η
	_mapW = new long[_maxScale];
	for(int i = 0; i < _maxScale; i++) {
		_mapW[i] = 360 * 600000.0 / (1 << (_maxScale - i -1)) + 0.5;
	}
}

QString GM_LiteMaps::searchMapFileName(long ns, long ew,
		Radian *radMapEW, Radian *radMapNS, Radian *radMapWidth,
		Radian *radMapHeight) {

	Coordinate tempCoordinate(ew, ns, 0);
	tempCoordinate.convTokyoToWGS84();

    _mapidX = ((tempCoordinate.getRadEW().toLong() / 600000.0 + 180)
	           / 360) * (1 << (_maxScale - _scale -1));
    _mapidY = (0.5 - log(
    		             tan((tempCoordinate.getRadNS().toLong() / -600000.0 + 90)
    		              	  * M_PI / 360))
    		             / (2 * M_PI))
    		  * (1 << (_maxScale - _scale -1));

    radMapEW->setData(long(((_mapidX + 0.5)* 360.0
                            / (1 << (_maxScale - _scale -1))
    		                - 180)
    		               * 600000));
    /*
    radMapNS->setData(long((90 -
    		        atan(exp((1 - (_mapidY + 0.5) * 2.0 
                                  / (1 << (_maxScale - _scale -1))
                             ) * M_PI))
                    / M_PI * 360) * 600000));
     */
    long mapNS = (90 -
    		        atan(exp((1 - _mapidY * 2.0 
                                  / (1 << (_maxScale - _scale -1))
                             ) * M_PI))
                    / M_PI * 360) * 600000;
    long mapNS2 = (90 - 
    		         atan(exp((1 - (_mapidY + 1) * 2.0 
                                   / (1 << (_maxScale - _scale -1))
                              ) * M_PI))
                     / M_PI * 360) * 600000;

    radMapHeight->setData(mapNS2 - mapNS);
	radMapWidth->setData(_mapW[_scale]);
	radMapNS->setData(mapNS + radMapHeight->toLong()/2);
    
    // ¬ϷѴ
	tempCoordinate.setRadEW(*radMapEW);
	tempCoordinate.setRadNS(*radMapNS);
	tempCoordinate.convWGS84ToTokyo();
	*(radMapEW) = tempCoordinate.getRadEW();
	*(radMapNS) = tempCoordinate.getRadNS();

	QString strTmp;
	QString rtnPath = _basePath + strTmp.sprintf("/%02d", _scale);

	QString strX;
	strX.sprintf("%010d", _mapidX);
	QString strY;
	strY.sprintf("%010d", _mapidY);
    for(int i = 0; i < 10; i++) {
    	rtnPath += "/" + strX.mid(i,1) + strY.mid(i,1);
    }
	return rtnPath + ".png";
}

QString GM_LiteMaps::pointMapFileName(int diffLat, int diffLong,
		Radian *radMapEW, Radian *radMapNS, Radian *radMapWidth,
		Radian *radMapHeight) {
	
	long newMapidX = _mapidX + diffLong;
	long newMapidY = _mapidY + diffLat;

    if(newMapidX < 0 || newMapidY < 0) {
    	return "";
    }

    long mapEW = long(((newMapidX + 0.5) * 360.0
    		           / (1 << (_maxScale - _scale -1))
    		           - 180)
    		          * 600000);
    /*
    long mapNS  = long((90 -
    		           atan(exp((1 - (newMapidY + 0.5) * 2.0 
                                     / (1 << (_maxScale - _scale -1))
                                ) * M_PI))
                       / M_PI * 360) * 600000);
     */
    long mapNS1 = long((90 -
    		           atan(exp((1 - newMapidY * 2.0 
                                     / (1 << (_maxScale - _scale -1))
                                ) * M_PI))
                       / M_PI * 360) * 600000);
    long mapNS2 = long((90 - 
    		            atan(exp((1 - (newMapidY + 1) * 2.0 
                                       / (1 << (_maxScale - _scale -1))
                                 ) * M_PI))
                        / M_PI * 360) * 600000);
    
	radMapWidth->setData(_mapW[_scale]);
	radMapHeight->setData(mapNS2 - mapNS1);

	// ¬ϷѴ
	Coordinate tempCoordinate(mapEW, mapNS1 + radMapHeight->toLong()/2, 0);
	tempCoordinate.convWGS84ToTokyo();
	*(radMapEW) = tempCoordinate.getRadEW();
	*(radMapNS) = tempCoordinate.getRadNS();

	QString strTmp;
	QString rtnPath = _basePath + strTmp.sprintf("/%02d", _scale);

	QString strX;
	strX.sprintf("%010d", newMapidX);
	QString strY;
	strY.sprintf("%010d", newMapidY);
    for(int i = 0; i < 10; i++) {
    	rtnPath += "/" + strX.mid(i,1) + strY.mid(i,1);
    }
	return rtnPath + ".png";
}

void GM_LiteMaps::changeScale(const QString &scale) {
	_scale = scale.toInt();
    if(_scale >= _maxScale)
    	_scale = _maxScale -1;
}
