/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include"mapCache.h"

MapCache::MapCache(int size = 12) {
	QImage tempImg;

	_nextId = 0;
	_cacheSize = size;
	for (int i = 0; i < size; i++) {
		_maps.push_back(tempImg);
		_mapFileNames.push_back("");
	}
}

QImage * MapCache::getMap(QString mapFileName) {
	for (int i = 0; i < _cacheSize; ++i)
		if (_mapFileNames[i] == mapFileName) {
			return &_maps[i];
		}
	
	_mapFileNames[_nextId] = mapFileName;
	if(_maps[_nextId].load(mapFileName)) {
		int rtnId = _nextId;
		if (++_nextId >= _cacheSize) {
			_nextId = 0;
		}
		return &_maps[rtnId];
	} else {
		_mapFileNames[_nextId] = "";
		return NULL;
	}
}
