/*
 * Copyright (C) 2009 HB1 <http://www.h7.dion.ne.jp/~rasiel/zega.html>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef ZEGA_H
#define ZEGA_H
#include<qwidget.h>
#include<qpe/config.h>
#include<qmenubar.h>
#include<qpopupmenu.h>
#include<qapplication.h>
#include<qmessagebox.h>
#include"qtkfiledialog.h"
#include<qimage.h>
#include<qpainter.h>
#include<qtimer.h>
#include"maplist.h"
#include"custommaplist.h"
#include"mobilemapnavimaps.h"
#include"gm_litemaps.h"
#include"gpsloghandler.h"
#include"mapCache.h"
#include"help.h"
#include"route.h"
#include"drawinfo.h"

/*
 #define _DEBUG_PRINT
*/
#define PIXEL_BASE 4

class Zega : public QWidget {
	Q_OBJECT

public:
	Zega(QWidget* parent, const char* name);
	~Zega();

	// static member
	static Config config;

protected:
	void paintEvent(QPaintEvent*);

private:
	void mousePressEvent(QMouseEvent *event);
	void resizeEvent(QResizeEvent *event);
	void keyPressEvent(QKeyEvent *event);
	void closeEvent(QCloseEvent *event);
	void paintMaps();
	void drawRoute();
	void drawGpsLog();
	void drawDestinationLine();
	void getEdgePoint(int *x, int *y, long dEW, long dNS);
	bool copyMap(int x, int y);
	void disableSuspend();
	void enableSuspend();

	QMenuBar *_menu;
	QPopupMenu *_filemenu;
	QPopupMenu *_gpsmenu;
	QPopupMenu *_scalemenu;
	QPopupMenu *_editmenu;
	QPopupMenu *_displaymenu;
	QPopupMenu *_helpmenu;
	MapCache *_mapCache;
	QImage *_buffer;
	QPixmap *_mapBuffer;
	MapList *_mapList;
	MobileMapNaviMaps *_mobileMapNaviMaps;
	GM_LiteMaps *_GM_LiteMaps;
	CustomMapList _customMapList;
	int _mapIndex;
	int _autoCenteredBounds;
	GpsLogHandler *_gpsLogHandler;
	QStringList mapDirs;

	// ̹ѤΥޡ
	QTimer *_updateTimer;

	// 濴κɸ
	Coordinate _center;
	long _pixelNS;
	long _pixelEW;
	int  _pixelBase;
	int _bsl, _bsr, _bsu, _bsd;
	bool _autoCentered;
	bool _showGpsLog;
	bool _showRoute;
	bool _showDestinationLine;
	bool _evenRePaint;
	
	// ϩ
	Route _route;
	
	// 
	QColor _routeColor;
	QColor _recentLogColor;
	QColor _obsoluteLogColor;
	QColor _currentPointColor;
	QColor _destinationLineColor;
	
	// 
	int _routeWidth;
	int _logWidth;
	int _destinationLineWidth;
	
	// ư
	int _cursorMoveDen;
	int _shiftCursorMoveDen;

    DrawInfo *_drawGpsInfo;
    DrawInfo *_drawMapInfo;

    Help *_help;
	
private slots:
void slotHelp();
void about();
void slotLoad();
void slotSaveRoute();
void slotChScale(int);
void slotRePaint();
void startGps();
void stopGps();
void slotToggleShowGpsLog();
void slotToggleShowRoute();
void slotToggleShowDestinationLine();
void slotToggleAutoCentered();
void slotAddRoutePoint();
void slotDelRoutePoint();
void slotReverseRoute();
void slotClearRoute();
void slotFullScreen();
void slotCalcRemainLength();
};

#endif //ZEGA_H
